extern "C"
{
#include "usefull.h"
#include "fxlib.h"
	#include <stdlib.h> 	
}

#include "MonochromeLib.h"
#include "game.h"
#include <stdio.h>
#include <string.h>

#define NB_SPRITE 10
#define NB_SNOW 200


unsigned char** sprites;
unsigned char** dataUnit;
unsigned char** nameUnit;
int frame;


void deleteAll()//on vide le tout
{
	for(int i = 0;i<NB_SPRITE;i++)
	{
		delete[] sprites[i];
	}
	delete[] sprites;

	for(int i = 0;i<MAX_CLASSES;i++)
	{

		delete[] nameUnit[i];
		
	}
	delete[] nameUnit;

	for(int i = 0;i<MAX_CLASSES;i++)
	{
		delete[] dataUnit[i];
	}
	delete[] dataUnit;
}


void loadSprites(int set)//on charge un set de sprites specifique
{
	unsigned char spriteBase[NB_SPRITE*32]=
	{
		0x1, 0x80, 0x6, 0x60, 0xc, 0x30, 0x30, 0xc, 0x60, 0x6, 0xa1, 0x5, 0x23, 0x84, 0x25, 0x4, 0x23, 0x84, 0x21, 0x44, 0x23, 0x84, 0x21, 0x4, 0x20, 0x4, 0x20, 0x4, 0x20, 0x4, 0x3f, 0xfc,
		0x1, 0x80, 0x6, 0x60, 0xc, 0x30, 0x30, 0xc, 0x60, 0x6, 0xa1, 0x5, 0x23, 0x84, 0x25, 0x4, 0x23, 0x84, 0x21, 0x44, 0x23, 0x84, 0x21, 0x4, 0x20, 0x4, 0x20, 0x4, 0x20, 0x4, 0x3f, 0xfc,
		0x0, 0x0, 0x1, 0xb8, 0x2, 0x68, 0x4, 0x28, 0x8, 0x18, 0x10, 0x8, 0x20, 0x4, 0x6c, 0x6, 0xac, 0x5, 0x20, 0xf4, 0x20, 0x94, 0x20, 0x94, 0x20, 0xd4, 0x20, 0x94, 0x20, 0x94, 0x3f, 0xfc, 
		
		0xf, 0x80, 0x15, 0x40, 0x15, 0x50, 0x10, 0x78, 0xf, 0xf2, 0x1f, 0xe5, 0xf, 0x82, 0x30, 0x40, 0x30, 0x60, 0x30, 0x5e, 0x30, 0x40, 0x1f, 0xc0, 0x8, 0x80, 0x8, 0x80, 0x8, 0x80, 0x8, 0x80,
		0x0, 0x0, 0x7, 0x0, 0x8, 0x80, 0xf, 0xbc, 0xd, 0xa2, 0x8, 0x9a, 0x7, 0xc, 0x8, 0xec, 0xc, 0x9c, 0xb, 0x98, 0x8, 0xf8, 0xf, 0xb0, 0x5, 0x30, 0x5, 0x60, 0x5, 0x60, 0x5, 0x0,
		0x0, 0x0, 0x8, 0x1c, 0x4, 0x32, 0x2, 0x69, 0x1, 0x45, 0x1, 0xcb, 0xff, 0x26, 0xd2, 0x1c, 0xd2, 0x30, 0xd1, 0xe0, 0xe0, 0x80, 0x0, 0x80, 0x0, 0xf0, 0x0, 0x88, 0x0, 0xf8, 0x0, 0xf8,
		0x1c, 0x0, 0x22, 0x0, 0x3e, 0x0, 0x36, 0x0, 0x22, 0x0, 0x1c, 0x40, 0x12, 0xa0, 0x11, 0x20, 0x10, 0xa0, 0x14, 0x9c, 0x15, 0xe2, 0xe, 0x2, 0x30, 0x2, 0x40, 0x7c, 0x43, 0x80, 0x3c, 0x0,
		0x7, 0xc0, 0x8, 0x20, 0x1f, 0xf0, 0xa, 0xa0, 0x12, 0x90, 0x10, 0x10, 0x48, 0x25, 0xc7, 0xe2, 0x78, 0x15, 0x90, 0x8, 0x20, 0x4, 0x20, 0x4, 0x20, 0x4, 0x10, 0x8, 0x8, 0x10, 0x7, 0xe0,
		0x1f, 0xfe, 0x30, 0x2, 0x60, 0x3, 0x4f, 0xfd, 0x78, 0xe6, 0x9, 0x14, 0x5, 0xf4, 0x5, 0xb4, 0xb, 0x1a, 0x11, 0xf2, 0x1f, 0x1c, 0x1, 0x10, 0x1, 0xf0, 0x0, 0xa0, 0x0, 0xa0, 0x0, 0xa0,
		};
	unsigned char ext[5] = {0};
	inttostring(set,(char*)ext);
	readFile("SNOWSPRI",ext,spriteBase);

	sprites = new unsigned char*[NB_SPRITE];
	for(int i = 0;i<NB_SPRITE;i++)
	{

		sprites[i] = new unsigned char[32];
		for(int j = 0;j<32;j++)
			{
				sprites[i][j] = spriteBase[i*32+j];
			}
	}

}


void loadNameUnit(int set)//on charge le nom des unites
{
	unsigned char nameBase[MAX_CLASSES*10]=
	{
		"Gamin    \000Hockeyeur\000Patineur \000SnowBoard\000Olaf     \000Glider   \000"
	};

	unsigned char ext[5] = {0};
	inttostring(set,(char*)ext);
	readFile("SNOWNAME",ext,nameBase);

	nameUnit = new unsigned char*[MAX_CLASSES];
	for(int i = 0;i<MAX_CLASSES;i++)
	{

		nameUnit[i] = new unsigned char[10];
		for(int j = 0;j<10;j++)
			{
				nameUnit[i][j] = nameBase[i*10+j];
			}
	}
}




void loadDataUnit(int set)//on charge les donnees des unites
{
unsigned char dataBase[MAX_CLASSES*6]=
	{//HP,ATK,DEF,VISION,MOUVEMENT,DISTANCE,LIGNE/INVOCATION/RIEN,PRIX 
		5 ,3 ,1,3,4,3,0,10,
		7 ,10,4,1,3,1,0,30,
		10,7 ,3,1,4,1,0,15,
		5 ,10,0,2,6,1,0,20,
		1 ,5 ,0,1,1,5,0,10,
		3 ,4 ,2,5,5,1,0,10,
	};
	unsigned char ext[5] = {0};
	inttostring(set,(char*)ext);
	readFile("SNOWDATA",ext,dataBase);

	dataUnit = new unsigned char*[MAX_CLASSES];
	for(int i = 0;i<MAX_CLASSES;i++)
	{

		dataUnit[i] = new unsigned char[8];
		for(int j = 0;j<8;j++)
			{
				dataUnit[i][j] = dataBase[i*8+j];
			}
	}
}




void drawSprite(int id,int x,int y,int size)//on affiche un sprite a la taille voulue
{
	
	if(id<1 ||id>9)return;

	for(int i = 0;i<size;i++)
	{
		for(int j = 0;j<size;j++)
		{
			if(sprites[id][ ((j*16/size)<<1 )+ (i>=((size+1)>>1))] & 1<<(7-(((i<<4)/size)&7)))ML_pixel(i+x,j+y,ML_BLACK);
			else ML_pixel(i+x,j+y,ML_WHITE);

		}

	}
}



unsigned char* getNameUnit(int ID)//fonction de depart, quand j'etait pas trop sur de comment j'allais faire ^^
{
return nameUnit[ID];

}


unsigned char** getDataUnit()//fonction de depart, quand j'etait pas trop sur de comment j'allais faire ^^
{
return dataUnit;
}


void Game::refreshFog(unsigned char player)//met le brouillard a neuf, en fonction du joueur actuel (le player pourrait etre remplacer par playerTurn, mais c'etait une fonction qui est arrivee trop tot et donc je l'ai faite generique)
{
for(int i = 0;i<sizeX;i++)
	for(int j = 0;j<sizeY;j++)
		fog[i][j] = 1;

for(int i = 0;i<nbBuilding;i++)
	{
		if(building[i].owner == player+1)pixelFog(building[i].X,building[i].Y,0,0);
	}

unsigned char** data = getDataUnit();

for(int i = 0;i<nbUnit[player];i++)
	{
		int vision = data[units[player][i].ID][3];
		for(int a = -vision;a<vision;a++)
		
			for(int b = -vision;b<vision;b++)

				if(abs(a)+abs(b) <vision)pixelFog(units[player][i].X+a,units[player][i].Y+b,0,0);
		
	}
}



void Game::changeFog(Unit unit,int dist)//on affiche la distance de mouvement/attaque
{
	unsigned char** data = getDataUnit();
	for(int a = -dist;a<=dist;a++)
		for(int b = -dist;b<=dist;b++)
			if(abs(a)+abs(b) <=dist && (a||b))pixelFog(unit.X+a,unit.Y+b,2,1);
}

void Game::pixelFog(int x,int y,int much,int mode)//on modifie un point du brouillard. L'interet etant si les X Y sortent des limites, pas d'erreurs
{
	if(x>=0 && y>=0 && x<sizeX && y<sizeY)
		{
			if(mode)fog[x][y]|=much;
			else fog[x][y] = much;
		}
}

Game::Game()
{
}


Game::~Game()//on vide le tout
{
for(int i = 0;i<sizeX;i++)delete[] fog[i];
delete[] fog;
deleteAll();
}


void Game::creation()//on cree une unite
{

	unsigned char infoName[7][10]=
	{
		"PV  :",
		"ATK :",
		"DEF :",
		"vue :",
		"dep :",
		"dist:"
	};
	int cursor = 0;
	int message = 0;

	while(true)
	{	

		if(key_down(K_UP))cursor--;
		if(key_down(K_DOWN))cursor++;
		cursor = (cursor+7)%7;

		if(key_down(K_EXE))
		{
			if(cursor == 6)return;
			if(infos[playerTurn].money >= dataUnit[cursor][7])
			{

				units[playerTurn][nbUnit[playerTurn]].X = infos[playerTurn].cursorX;
				units[playerTurn][nbUnit[playerTurn]].Y = infos[playerTurn].cursorY;
				units[playerTurn][nbUnit[playerTurn]].ID = cursor;
				units[playerTurn][nbUnit[playerTurn]].HP = dataUnit[cursor][0];
				units[playerTurn][nbUnit[playerTurn]].tired = 1;
				nbUnit[playerTurn]++;
				infos[playerTurn].money -= dataUnit[cursor][7];
				return;
			}
			else message = 1;
		}
		ML_rectangle(5,5,123,58,1,ML_BLACK,ML_WHITE);
		ML_line(5,14,123,14,ML_BLACK);
		ML_line(70,15,70,58,ML_BLACK);

		if(message) PrintMini(7,7,"pas assez d'argent !",1);
		else 		PrintMini(7,7,"chez Josette - argent :",1);
		PrintV(108,7,infos[playerTurn].money);
		
		for(int i = 0;i<6;i++)
		{
			PrintMini(7,16+i*6,getNameUnit(i),1);
			PrintV(50,16+i*6,dataUnit[i][7]);
		}
		PrintMini(7,52,"sortir",1);

		for(int i = 0;i<6;i++)
		{
			PrintMini(72,16+i*6,infoName[i],1);
			PrintV(104,16+i*6,dataUnit[cursor][i]);
		}

		ML_rectangle(6,15+cursor*6,69,15+cursor*6+6,0,ML_XOR,ML_XOR);
		ML_display_vram();
		setFps(8);
	}
}


void Game::attack(Unit* atk,Unit* def)//une unite attaque une autre 
{
	def->HP -= dataUnit[atk->ID][1]-dataUnit[def->ID][2];
}

void Game::options()//le choix de depart pour la partie
{
	int camera = 0;
	int cursor = 0;
	int optionY[6]={20,28,36,44,52,60};
	unsigned char name[6][30] ={"argent depart","argent/chalet","map","set d'unite","neige","valider"};
	unsigned char answer[6][30] = {"100","2","1","1","oui"};
	unsigned char snowYesNo[2][10]={"non","oui"};
	int answerNum[5] = {3,3,0,0,1};
	while(1)
	{

		if(key_down(K_UP) && cursor)cursor--;
		if(key_down(K_DOWN) && cursor<5)cursor++;

		if(key_down(K_EXE) && cursor == 5)break;

		if(key_down(K_EXE) || key_down(K_RIGHT))answerNum[cursor]++;
		if(key_down(K_LEFT))answerNum[cursor]--;


		for(int i = 0;i<4;i++)answerNum[i] = min(max(answerNum[i],0),99);
		answerNum[4] = answerNum[4]&1;
		inttostring(answerNum[0]*10,(char*)answer[0]);
		for(int i = i;i<4;i++)inttostring(answerNum[i],(char*)answer[i]);
		memcpy(answer[4],snowYesNo[answerNum[4]],10);

		if(optionY[cursor]>camera+50)camera++;
		if(optionY[cursor]<camera)camera--;


		PrintXY(18,4-camera,"nouvelle partie",0);
		for(int i = 0;i<6;i++)
		{
			PrintMini(8,optionY[i]-camera,name[i],0);
			if(i != 5)PrintMini(70,optionY[i]-camera,":",0);
			PrintMini(76,optionY[i]-camera,answer[i],0);
		}
	
		PrintMini(2,optionY[cursor]-camera,"-",0);

		snowFall();
		ML_rectangle(0,0,128,64,0,ML_XOR,ML_XOR);
		ML_display_vram();
		ML_clear_vram();
		setFps(8);
	}


	snowFalling = answerNum[4];
	goldRate = answerNum[1];
	unitSet = answerNum[3];
	map = answerNum[2];

	for(int i = 0;i<nbPlayer+nbCPU;i++)
	{
		infos[i].money = answerNum[0]*10;
	}

}


void Game::generateMap()//on cree une map ou on la charge depuis un fichier
{


	unsigned char base[MAX_BUILDING*4]={
		25,16,36,
		1,7,1,1,
		1,9,1,1,
		3,7,2,1,
		3,9,2,1,
		23,7,1,2,
		23,9,1,2,
		21,7,2,2,
		21,9,2,2};



	for(int i = 0;i<20;i++)
	{
		base[i*4+35] = random(5,19);
		base[i*4+36] = random(0,15);
		if(random(0,10))base[i*4+37] = 2;
		else base[i*4+37] = 1;
		base[i*4+38] = 0;
	}



	unsigned char ext[5] = {0};
	inttostring(map,(char*)ext);
	readFile("SNOWMAP",ext,base);//si la map n'est pas trouvee, alors base n'est pas modifie


	sizeX = base[0];
	sizeY = base[1];
	nbBuilding = base[2];

	for(int i = 0;i<nbBuilding;i++)
	{
		building[i].X = base[i*4+3];
		building[i].Y = base[i*4+4];
		building[i].ID = base[i*4+5];
		building[i].owner = base[i*4+6];
		building[i].turn = 0;
	}







	infos[0].cursorX = 3;
	infos[1].cursorX = sizeX-4;
	for(int i = 0;i<nbPlayer;i++)
	{
		nbUnit[i]=0;
		infos[i].cursorY = sizeY>>1;
	}
}


int Game::checkCollision(int X,int Y)//on verifie si il n'y a pas d'unite sur cette case
{
for(int i = 0;i<nbPlayer+nbCPU;i++)
	for(int j = 0;j<nbUnit[i];j++)
		if(units[i][j].X == X && units[i][j].Y == Y )return i;

return -1;
}


void victory(int winner)//on affiche la victoire d'un des joueurs
{
	while(key_down(K_EXE))Sleep(5);
	while(!key_down(K_EXE))
	{
		PrintMini(20,10,"Victoire du joueur   !",1);
		PrintV(94,10,winner+1);
		PrintMini(7,25,"Vous regnez sans partage sur",1);
		PrintMini(9,35,"le monde des sports d'hiver!",1);
		PrintMini(0,52,"Programme par Dodormeur pour",1);
		PrintMini(0,58,"les 14eme CPC de Planete-Casio",1);
		snowFall();
		ML_rectangle(0,0,128,64,0,ML_XOR,ML_XOR);
		ML_display_vram();
		ML_clear_vram();
		setFps(8);

	}
	while(key_down(K_EXE));

}

int Game::checkEnd()//on verifie si un joueur a gagne
{
	char alive[MAX_PLAYER] = {0};
	int winner = -1;
	for(int i = 0;i<nbBuilding;i++)
		{
			if(building[i].owner)alive[building[i].owner-1] = 1;
		}
	for(int i = 0;i<nbPlayer+nbCPU;i++)
	{
		if(alive[i])
		{
			if(winner == -1)winner = i;
			else return -1;
		}
	}
	return winner;

}

void Game::start(int newGame)//on commence une partie !
{
	const unsigned char barre[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0x0, 0x4, 0x0, 0x0, 0x40, 0x0, 0x2, 0x0, 0x0, 0x10, 0x0, 0x0, 0x80, 0x0, 0x0, 0x0, 0x40, 0x4, 0x0, 0x0, 0x40, 0xfc, 0x2, 0x0, 0xc0, 0x11, 0xd8, 0x90, 0x9d, 0x60, 0x88, 0x0, 0x40, 0x4, 0x0, 0x0, 0x40, 0xb4, 0x2, 0x3, 0x30, 0x10, 0x95, 0x28, 0x90, 0x50, 0xd4, 0x3, 0xf8, 0x4, 0x7, 0xe0, 0x40, 0xb4, 0x2, 0x6, 0x18, 0x10, 0x95, 0xa8, 0x99, 0x50, 0x94, 0x0, 0x40, 0x4, 0x0, 0x0, 0x40, 0x84, 0x2, 0x2, 0x50, 0x10, 0x95, 0x28, 0x91, 0x50, 0x94, 0x0, 0x40, 0x4, 0x0, 0x0, 0x40, 0xb4, 0x2, 0x2, 0x50, 0x11, 0xd5, 0x10, 0x91, 0x50, 0x48, 0x0, 0x0, 0x4, 0x0, 0x0, 0x40, 0xfc, 0x2, 0x3, 0xf0, 0x10, 0x0, 0x0, 0x80, 0x0, 0x0, };

	int cameraX = 0;
	int cameraY = 0;

	int centerCameraX = 0;
	int centerCameraY = 0;

	int cameraSpeed = 1;
	int X = 0;
	int Y = 0;
	unsigned int key;
	unsigned char UIMenu = 0;
	unsigned char motion = 0;
	Unit* unitSelected = 0;
	bool released = true;

	char motionX[10] = {0,0,0,0,0,0,0,0};
	char motionY[10] = {0,0,0,0,0,0,0,0};
	char motionPointer = 0;
	char motionPointer2 = 1;

	char atkX = 0;
	char atkY = 0;

	zoom = 16;
	playerTurn = 0;

	if(newGame == 2)//nouvelle partie
	{	
		nbCPU = 0;
		nbPlayer=2;
		//if(multi == 1)nbCPU = 1;
		//if(multi == 2)nbPlayer =2;
		options();
		generateMap();
	}
	else //on charge la partie en cours
	{
		load();
	}


	fog = new unsigned char* [sizeX];
	for(int i = 0;i<sizeX;i++)fog[i]= new unsigned char[sizeY];


	loadSprites(unitSet);
	loadDataUnit(unitSet);
	loadNameUnit(unitSet);

	refreshFog(playerTurn);


	while(1)
	{
		if(!motion)//mode normal
		{
			if(key_down(K_UP))infos[playerTurn].cursorY--;
			if(key_down(K_DOWN))infos[playerTurn].cursorY++;
			if(key_down(K_LEFT))infos[playerTurn].cursorX--;
			if(key_down(K_RIGHT))infos[playerTurn].cursorX++;

			if(key_down(K_EXE))
			{
				while(key_down(K_EXE))Sleep(5);

				for(int i = 0;i<nbUnit[playerTurn];i++)
					if(infos[playerTurn].cursorX == units[playerTurn][i].X && infos[playerTurn].cursorY == units[playerTurn][i].Y && !units[playerTurn][i].tired)
						{
							changeFog(units[playerTurn][i],dataUnit[units[playerTurn][i].ID][4]);
							unitSelected = &units[playerTurn][i];
							motion = 1;
							motionPointer = 0;
						}

				for(int i = 0;i<nbBuilding;i++)
					if(infos[playerTurn].cursorX == building[i].X && infos[playerTurn].cursorY == building[i].Y &&  building[i].ID == 1 && building[i].owner-1 == playerTurn)
					{
						bool flag = true;
						for(int j = 0;j<nbPlayer+nbCPU;j++)
							for(int k = 0;k<nbUnit[j];k++)
								if(units[j][k].X == building[i].X && units[j][k].Y == building[i].Y)flag = false;
						if(flag)
						{
							creation();
							flag = false;
							break;
						}

					}

				refreshFog(playerTurn);
				while(key_down(K_EXE))Sleep(5);
			}

			if(key_down(K_F1))zoom++;
			if(key_down(K_F2))zoom--;

			if(key_down(K_F3))save();
			if(key_down(K_F4)){save();return;}
			if(key_down(K_F5))drawInfo = !drawInfo;
			if(key_down(K_F6))
			 	{

			 		for(int i = 0;i<nbBuilding;i++)
			 		{
			 			if(building[i].owner == playerTurn+1 && building[i].ID == 2)infos[playerTurn].money+=goldRate;
			 		}
			 		for(int i = 0;i<nbUnit[playerTurn];i++)if(units[playerTurn][i].tired)units[playerTurn][i].tired--;
			 		playerTurn++;
			 		playerTurn%=(nbPlayer+nbCPU);
			 		if(!playerTurn)turn ++;
			 		ML_clear_vram();
			 		PrintV(36,29,playerTurn+1);
			 		
			 		if(playerTurn)PrintMini(40,29,"eme joueur !",1);
			 		else PrintMini(40,29,"er joueur !",1);
			 		PrintV(40,39,turn+1);
			 		PrintMini(40,39,"  tour !",1);
			 		//GetKey(&key); getkey c'est nul, ca marche pas bien
					ML_rectangle(0,0,128,64,0,ML_XOR,ML_XOR);
			 		ML_display_vram();
			 		ML_clear_vram();
			 		while(!key_down(K_EXE))Sleep(5);
			 		while(key_down(K_EXE))Sleep(5);
					refreshFog(playerTurn);

					int captured = 0;
					for(int i = 0;i<nbBuilding;i++)
			 		{
			 			if(building[i].owner != playerTurn+1)
		 				{
			 				for(int j = 0;j<nbUnit[playerTurn];j++)
			 				{
			 					Unit temp = units[playerTurn][j];
			 					if(temp.X == building[i].X && temp.Y == building[i].Y)
			 					{
			 						building[i].turn++;
			 					}
			 					if(building[i].turn>(3 - 2*(building[i].owner==0)))
			 					{
			 						//Sleep(5000);
			 						building[i].owner = playerTurn+1;
			 						captured++;
			 						building[i].turn = 0;
			 						break;
			 					}

			 				}
		 				}
			 		}
			 		if(captured)
			 		{
						PrintMini(20,29,"batiments captures :",1);
			 			PrintV(102,29,captured);
				 		//GetKey(&key); getkey c'est nul, ca marche pas bien
						ML_rectangle(0,0,128,64,0,ML_XOR,ML_XOR);
				 		ML_display_vram();
				 		while(!key_down(K_EXE))Sleep(5);
				 		while(key_down(K_EXE))Sleep(5);

			 		}
			 		int end = checkEnd();
			 		if(end != -1)
			 		{
			 			victory(end);
			 			return;
			 		}
		 		}

		}
		else if(motion == 1)//mode je fais le chemin d'une unite
		{
			if(released && motionPointer<10)
			{
				released = false;
				if(key_down(K_UP))
				{
					motionX[motionPointer+1] = motionX[motionPointer];
					motionY[motionPointer+1] = motionY[motionPointer]-1;
				}
				else if(key_down(K_DOWN))
				{
					motionX[motionPointer+1] = motionX[motionPointer];
					motionY[motionPointer+1] = motionY[motionPointer]+1;
				}
				else if(key_down(K_LEFT))
				{
					motionX[motionPointer+1] = motionX[motionPointer]-1;
					motionY[motionPointer+1] = motionY[motionPointer];
				}
				else if(key_down(K_RIGHT))
				{
					motionX[motionPointer+1] = motionX[motionPointer]+1;
					motionY[motionPointer+1] = motionY[motionPointer];
				}
				else motionPointer--;
				motionPointer++;
			}
			if(!key_down(K_UP) && !key_down(K_DOWN) && !key_down(K_LEFT) && !key_down(K_RIGHT))released = true;

			for(int i = 0;i<=motionPointer;i++)
				for(int j = 0;j<i;j++)
				{
					if(motionX[i]==motionX[j] && motionY[i] == motionY[j]){motionPointer = j;break;}
				}
			if(key_down(K_EXE))motion++;
		}
		else if(motion<100)//mode l'unite bouge
	 	{
 			int deltaX = motionX[motionPointer2]-motionX[motionPointer2-1];
 			int deltaY = motionY[motionPointer2]-motionY[motionPointer2-1];

 			motionPointer2++;

			if(motionPointer2-1 > motionPointer || motionPointer2-1 >dataUnit[unitSelected->ID][4])
			{
				motion = 100;
				motionPointer2 = 1;
		 		motionPointer = 0;
		 		refreshFog(playerTurn);
			}
 			else if(checkCollision(unitSelected->X+deltaX,unitSelected->Y+deltaY) != -1)
 			{
 				motion = 0;
 				motionPointer2 = 1;
 				motionPointer = 0;
 				unitSelected->tired = 1;
	 			refreshFog(playerTurn);
 			}
 			else
 			{
 				unitSelected->X+=deltaX;
 				unitSelected->Y+=deltaY;
 				/*infos[playerTurn].cursorX +=deltaX;
 				infos[playerTurn].cursorY +=deltaY;*/
 			}
	 	}
	 	else//mode l'unite attaque (le motion a 100 est a cause d'une idee de debut qui n'a pas vu le jour)
	 	{
			if(key_down(K_UP))infos[playerTurn].cursorY--;
			if(key_down(K_DOWN))infos[playerTurn].cursorY++;
			if(key_down(K_LEFT))infos[playerTurn].cursorX--;
			if(key_down(K_RIGHT))infos[playerTurn].cursorX++;

	 		changeFog(*unitSelected,dataUnit[unitSelected->ID][5]);

	 		if(key_down(K_EXE))
	 		{
	 			int targetX = infos[playerTurn].cursorX;
	 			int targetY = infos[playerTurn].cursorY;
	 			if(abs(targetX- unitSelected->X) +  abs(targetY- unitSelected->Y) <=dataUnit[unitSelected->ID][5])
	 			{
	 				for(int i = 0;i<nbPlayer+nbCPU;i++)
	 				{
	 					for(int j = 0;j<nbUnit[i];j++)
	 					{
	 						if(units[i][j].X == targetX && units[i][j].Y == targetY)
	 						{
	 							attack(unitSelected,&units[i][j]);
	 							if(units[i][j].HP<=0)
	 							{
	 								units[i][j].X = units[i][nbUnit[i]-1].X;
	 								units[i][j].Y = units[i][nbUnit[i]-1].Y;
	 								units[i][j].ID = units[i][nbUnit[i]-1].ID;
	 								units[i][j].HP = units[i][nbUnit[i]-1].HP;
	 								nbUnit[i]--;
	 							}
	 							i = 99;
	 							break;
	 						}
	 					}
	 				}
	 			}
 				unitSelected->tired = 1;
 				motion = 0;

	 		}
	 	}
		


		infos[playerTurn].cursorY = max(min(infos[playerTurn].cursorY,sizeY-1),0);
		infos[playerTurn].cursorX = max(min(infos[playerTurn].cursorX,sizeX-1),0);

		


		
		//on centre la camera

		int oldCamX = cameraX;
		int oldCamY = cameraY;
		centerCameraX = infos[playerTurn].cursorX;
		centerCameraY = infos[playerTurn].cursorY;

		if(motion == 1)
		{
			centerCameraX = infos[playerTurn].cursorX+motionX[motionPointer];
			centerCameraY = infos[playerTurn].cursorY+motionY[motionPointer];
		}

		if(centerCameraY*zoom<cameraY+35)cameraY-=cameraSpeed;
		//if(infos[playerTurn].cursorY*zoom<cameraY)cameraY-=2;

		if(centerCameraY*zoom>cameraY-35+50)cameraY+=cameraSpeed;
		//if(infos[playerTurn].cursorY*zoom>cameraY+50)cameraY+=2;

		if(centerCameraX*zoom<cameraX+10)cameraX-=cameraSpeed;
		//if(infos[playerTurn].cursorX*zoom<cameraX)cameraX-=2;

		if(centerCameraX*zoom>cameraX-10+110)cameraX+=cameraSpeed;
		//if(infos[playerTurn].cursorX*zoom>cameraX+110)cameraX+=2;

		if(cameraSpeed<zoom+2)cameraSpeed++;
		if(oldCamX == cameraX && oldCamY == cameraY){if(UIMenu<7)UIMenu++;cameraSpeed = 1;}
		else UIMenu = 0;


		zoom = max(min(zoom,16),1);

		bool flag = true;
		for(int i = 0;i<nbUnit[playerTurn];i++)
			if(units[playerTurn][i].X == infos[playerTurn].cursorX && units[playerTurn][i].Y == infos[playerTurn].cursorY)
			{
				if(!units[playerTurn][i].tired && motion != 100)changeFog(units[playerTurn][i],dataUnit[units[playerTurn][i].ID][4]);
				flag = false;
				break;
			}
		if(flag && !motion)refreshFog(playerTurn);



		int cursorScreenX = infos[playerTurn].cursorX*zoom-cameraX;
		int cursorScreenY = infos[playerTurn].cursorY*zoom-cameraY;

		ML_clear_vram();
		drawMap(cameraX,cameraY,zoom,fog);
		ML_rectangle(cursorScreenX,cursorScreenY,cursorScreenX+zoom,cursorScreenY+zoom,1,ML_BLACK,ML_TRANSPARENT);
		
		if(motion)//on affiche le chemin de l'unite
		{
			for(int i = motionPointer2-1;i<motionPointer;i++)
			{
				ML_line(cursorScreenX+motionX[i]*zoom+zoom/2,cursorScreenY+motionY[i]*zoom+zoom/2,cursorScreenX+motionX[i+1]*zoom+zoom/2,cursorScreenY+motionY[i+1]*zoom+zoom/2,ML_XOR);

			}

		}

		if(snowFalling)snowFall();//neige ! \o/

		ML_bmp_and_cl(barre,0,63-UIMenu,128,64);
		ML_bmp_or_cl(barre,0,63-UIMenu,128,64);

		if(drawInfo)
			{
				int infoX = drawInfo-6;
				ML_rectangle(-1,-1,128,drawInfo,1,ML_BLACK,ML_WHITE );
				PrintMini(10,infoX,"argent :",1);
				PrintV(50,infoX,infos[playerTurn].money);
				for(int i = 0;i<nbUnit[playerTurn];i++)
					if(units[playerTurn][i].X == infos[playerTurn].cursorX && units[playerTurn][i].Y == infos[playerTurn].cursorY)
					{
						PrintMini(80,infoX,"PV :",1);
						PrintV(100,infoX,units[playerTurn][i].HP);
					}
				if(drawInfo<7)drawInfo++;
			}
		ML_display_vram();
		setFps(8);
		frame++;

	}
}



void Game::save()//on sauvegarde
{
	unsigned char save[1500] = {0};
	int pointer = 10;
	save[0]=fogActive;
	save[1]=turn;
	save[2]=nbPlayer;
	save[3]=nbCPU;
	save[4]=nbBuilding;
	save[5]=goldRate;
	save[6]=playerTurn;
	save[7]=snowFalling;
	save[8]=sizeX;
	save[9]=sizeY;


	for(int i = 0;i<nbPlayer+nbCPU;i++)
	{
		save[++pointer] =nbUnit[i];
		for(int j = 0;j<nbUnit[i];j++)
		{	
			save[++pointer] = units[i][j].X;
			save[++pointer] = units[i][j].Y;
			save[++pointer] = units[i][j].ID;
			save[++pointer] = units[i][j].HP;
			save[++pointer] = units[i][j].tired;
		}
		save[++pointer] = infos[i].cursorX;
		save[++pointer] = infos[i].cursorY;
		save[++pointer] = infos[i].zoom;
		save[++pointer] = infos[i].money/100;
		save[++pointer] = infos[i].money%100;
	}

	for(int i = 0;i<nbBuilding;i++)
	{

		save[++pointer] = building[i].X;
		save[++pointer] = building[i].Y;
		save[++pointer] = building[i].ID;
		save[++pointer] = building[i].owner;
		save[++pointer] = building[i].turn;
	}
	

	writeFile("snowW","sav",save,pointer+1);
}


void Game::load()//on charge
{

	unsigned char save[1500] = {0};

	readFile("snowW","sav",save);

	int pointer = 10;
	fogActive 	= save[0];//vive le mutli-curseur de sublimeText \o/
	turn 		= save[1];
	nbPlayer 	= save[2];
	nbCPU  		= save[3];
	nbBuilding  = save[4];
	goldRate   	= save[5];
	playerTurn  = save[6];
	snowFalling = save[7];
	sizeX 		= save[8];
	sizeY 		= save[9];

	for(int i = 0;i<nbPlayer+nbCPU;i++)
	{
		nbUnit[i] = save[++pointer];
		for(int j = 0;j<nbUnit[i];j++)
		{	
			units[i][j].X 		= save[++pointer];
			units[i][j].Y 		= save[++pointer];
			units[i][j].ID 		= save[++pointer];
			units[i][j].HP 		= save[++pointer];
			units[i][j].tired	= save[++pointer];
		}
		infos[i].cursorX = save[++pointer];
		infos[i].cursorY = save[++pointer];
		infos[i].zoom = save[++pointer];
		infos[i].money = save[++pointer]*100;
		infos[i].money += save[++pointer];
	}

	for(int i = 0;i<nbBuilding;i++)
	{

		building[i].X = save[++pointer];
		building[i].Y = save[++pointer];
		building[i].ID = save[++pointer];
		building[i].owner = save[++pointer];
		building[i].turn = save[++pointer];
	}

	
}





void Game::drawMap(int cameraX,int cameraY,int zoom,unsigned char** fog)//on affiche les unites, les batiments et le brouillard
{
	int startingTileX = cameraX/zoom-1;
	int startingTileY = cameraY/zoom-1;
	int endingTileX = startingTileX+128/zoom+2;
	int endingTileY = startingTileY+64/zoom+2;

	for(int i = 0;i<nbBuilding;i++)
	{
		if(building[i].X<=endingTileX && building[i].X>=startingTileX && building[i].Y<=endingTileY && building[i].Y>=startingTileY && building[i].ID && building[i].ID<3)
		{
			drawSprite(building[i].ID,building[i].X*zoom-cameraX,building[i].Y*zoom-cameraY,zoom);
			if(frame&16)if(building[i].owner)PrintV(building[i].X*zoom-cameraX+zoom-3,building[i].Y*zoom-cameraY+zoom-5,building[i].owner);
		}
		
	}

	for(int i = 0;i<nbPlayer+nbCPU;i++)	
	{
		for(int j = 0;j<nbUnit[i];j++)
		{
			if(units[i][j].X<=endingTileX && units[i][j].X>=startingTileX && units[i][j].Y<=endingTileY && units[i][j].Y>=startingTileY)
			{
				drawSprite(units[i][j].ID+3,units[i][j].X*zoom-cameraX,units[i][j].Y*zoom-cameraY,zoom);
				if(frame&16)
				{
					PrintV(units[i][j].X*zoom-cameraX+zoom-3,units[i][j].Y*zoom-cameraY+zoom-5,i+1);
					if(units[i][j].tired)
						{
							ML_rectangle(units[i][j].X*zoom-cameraX,units[i][j].Y*zoom-cameraY+zoom-5,units[i][j].X*zoom-cameraX+3,units[i][j].Y*zoom-cameraY+zoom,0,ML_WHITE,ML_WHITE);
							PrintMini(units[i][j].X*zoom-cameraX,units[i][j].Y*zoom-cameraY+zoom-5,"x",1);
						}
				}
			}
		}
	}


	for(int i = startingTileX;i<=endingTileX;i++)
		for(int j = startingTileY;j<=endingTileY;j++)
		{
			if(i>=0 && j>=0 && i<sizeX && j<sizeY) 
			{
				if(fog[i][j]&1)ML_rectangle(i*zoom-cameraX,j*zoom-cameraY,i*zoom-cameraX+zoom,j*zoom-cameraY+(zoom-1),0,ML_CHECKER,ML_CHECKER);
				if(fog[i][j]&2 && !(frame&12))ML_rectangle(i*zoom-cameraX,j*zoom-cameraY,i*zoom-cameraX+zoom,j*zoom-cameraY+(zoom-1),0,ML_BLACK,ML_BLACK);
			}
			else ML_rectangle(i*zoom-cameraX,j*zoom-cameraY,i*zoom-cameraX+zoom,j*zoom-cameraY+(zoom-1),0,ML_BLACK,ML_BLACK);
		}
}





void snowFall()//on fait tomber de la neige :D
{
	static int positionX[NB_SNOW] = {0};
	static int positionY[NB_SNOW] = {0};
	static int sizeRow[129]={0};
	static int state[NB_SNOW] = {0};

	if(!(rand()%4))
	{
		for(int i = 0;i<NB_SNOW;i++)
		{
			if(state[i] == 0)
			{
				positionX[i] = random(-64,110);
				positionY[i] = 0;
				state[i]= 1;
				break;
			}
		}
	}

	for(int i = 0;i<NB_SNOW;i++)
	{
		if(state[i] == 1)
			{
				positionX[i]+=random(-1,2);
				positionY[i]+=random(0,2);
				if(64-sizeRow[positionX[i]] <=positionY[i] || 64-sizeRow[positionX[i]+1] <=positionY[i] || 64-sizeRow[positionX[i]-1] <=positionY[i])
				{
					sizeRow[positionX[i]]++;
					state[i]=2;
				}
			}
		if(state[i]>1)state[i]++;
		if(state[i]==500)
		{
			sizeRow[positionX[i]]--;
			state[i]=0;
		}

		if(positionX[i]>128)state[i]=0;
	}

	for(int i = 0;i<NB_SNOW;i++)
	{
		if(state[i] == 1)ML_pixel(positionX[i],positionY[i],ML_BLACK);
	}
	for(int i = 0;i<128;i++)
	{
		ML_line(i,64,i,64-sizeRow[i],ML_BLACK);
	}
}