#ifndef GAME
#define GAME


#define MAX_UNIT 30
#define MAX_BUILDING 50
#define MAX_PLAYER 8
#define MAX_CLASSES 10

void drawSprite(int id,int x,int y,int size);
void loadSprites();
void loadDataUnit();
void loadNameUnit();
unsigned char** getDataUnit();
unsigned char* getNameUnit(int ID);
void snowFall();
void deleteAll();

struct Unit
{
	unsigned char X;
	unsigned char Y;
	unsigned char ID;
	char HP;
	unsigned char tired;
};

struct Building
{
	unsigned char X;
	unsigned char Y;
	unsigned char ID;
	unsigned char owner;
	unsigned char turn;
};

struct Info
{
	char cursorX;
	char cursorY;
	unsigned char zoom;
	int money;
};

class Game
{
	public:

		Game();
		~Game(); 

		void start(int newGame);
		void options();
		void generateMap();
		void drawMap(int cameraX,int cameraY,int zoom,unsigned char** fog);
		void refreshFog(unsigned char player);
		void creation();
		void load();
		void save();
		void pixelFog(int x,int y,int much,int mode);
		void changeFog(Unit unit,int dist);
		int checkCollision(int X,int Y);
		void attack(Unit* atk,Unit* def);
		int checkEnd();

	private:

		bool fogActive;//finalement ce n'est pas utilise
		unsigned char turn;//nombre de tour ecoule
		unsigned char nbPlayer;//nombre de joueur humain
		unsigned char nbCPU;//nombre d'ordinateur (pas vraiment utilise)
		unsigned char nbBuilding;//nombre de batiment
		unsigned char zoom;//niveau de zoom, de 1 a 16

		unsigned char goldRate;//or gagne par tour et par chalet
		unsigned char playerTurn;//a quel joueur est-ce le tour

		unsigned char snowFalling;//est-ce que la neige doit tomber?
		unsigned char drawInfo;//faut-il dessiner les infos?

		unsigned char unitSet;//set d'unite
		unsigned char map;//la carte selectionnee


		unsigned char** fog;//l'etat du brouillard
		unsigned char sizeX,sizeY;//taille de la carte
		Unit units[MAX_PLAYER][MAX_UNIT];//les unites des joueurs
		Info infos[MAX_PLAYER];//les informations sur chaque joueur (argent, curseurXY, etc.)
		unsigned char nbUnit[MAX_PLAYER];//le nombre d'unite de chaque joueur
		Building building[MAX_BUILDING];//les batiments (position, id, maitre, etc.)
};
#endif